{
WTVIRBridge
Copyright (c) 2004-07 Oliver Frietsch

WTVIRBridge is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WTVIRBridge is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
}

unit broadcast; {OK}
//The customizable unit!

interface

{$INCLUDE defines.inc}

{$IFDEF DIRC}
  const BroadcastType = 'DIRC'; //Displayed in about dialog - just for informational purposes
{$ENDIF}{$IFDEF WINLIRC}
  const BroadcastType = 'WinLIRC';
{$ENDIF}

procedure BeginBroadcast;
//Called on startup

procedure BroadcastKey (Address, KeyCode: Integer);
//Called on every keypress
//Address = remote type; KeyCode = remote key code (see lngstrings.pas for reference)

procedure EndBroadcast;
//Called on exit

implementation

{$IFDEF DIRC}
  uses
    Windows, Messages, CoolTrayIcon, main, lngstrings, log;

  var
    DIRCWindowHwnd: THandle;

  procedure BeginBroadcast;
  begin
    DIRCWindowHwnd := 0;
  end;

  procedure BroadcastKey (Address, KeyCode: Integer);
  begin
    if (DIRCWindowHwnd = 0) or (not IsWindow (DIRCWindowHwnd))
      then DIRCWindowHwnd := FindWindow ('TDIRCMainForm', nil);
    if DIRCWindowHwnd = 0
      then begin
             LogForm.LogEvent (WarningFindDIRCWindow);
             ShowBalloonHint (WarningTitle, WarningFindDIRCWindow, bitWarning, 10);
           end
      else PostMessage (DIRCWindowHwnd, wm_User, address, keycode);
  end;

  procedure EndBroadcast;
  begin
  end;
{$ENDIF}{$IFDEF WINLIRC}
  uses
    fakewinlircthread;

  var
    Thread: TFakeWinLIRCThread;

  procedure BeginBroadcast;
  begin
    Thread := TFakeWinLIRCThread.Create;
  end;

  procedure BroadcastKey (Address, KeyCode: Integer);
  begin
    Thread.SendKey (Address, KeyCode);
  end;

  procedure EndBroadcast;
  begin
    if not Thread.Suspended
      then begin
             Thread.Terminate;
             Thread.WaitFor;
           end;
    Thread.Free;
  end;
{$ENDIF}

end.
