{
WTVIRBridge
Copyright (c) 2004-07 Oliver Frietsch

WTVIRBridge is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WTVIRBridge is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
}

unit lngstrings; {OK}

interface

{$INCLUDE defines.inc}

const
  UnknownRemote = 'Unknown remote';
  UnknownKey = 'Unknown key';
  DateFormat = 'dd/mm/yyyy hh:nn:ss';
  ErrorTitle = 'WTVIRBridge Error';
  WarningTitle = 'WTVIRBridge Warning';
  ErrorOpenDevice = 'Unable to open IR device.'#13#10'Maybe you didn''t install all necessary drivers.';
  ErrorSaveLog = 'Unable to save log.';
  IROpenRequest = 'An external application requested an IR_Open.';
  IROpenSuccess = 'IR_Open successful.';
  IROpenFailed = 'IR_Open failed.';
  IRCloseRequest = 'An external application requested an IR_Close.';
  IRCloseSuccess = 'IR_Close successful.';
  IRCloseFailed = 'IR_Close failed.';
  KeyLogEntry = 'Key:';

  {$IFDEF DIRC}
    WarningFindDIRCWindow = 'Unable to find DIRC''s window.'#13#10'Maybe DIRC isn''t running.';
  {$ENDIF}{$IFDEF WINLIRC}
    ErrorBindServer = 'Unable to bind server. The TCP port (8765) may already be in use by another application.';
    BindServerSuccess = 'Binding of server successful.';
    BindServerFailed = 'Binding of server failed.'; 
  {$ENDIF}

function GetRemoteName (Address: Integer): String;
function GetKeyName (Address, KeyCode: Integer): String;

implementation

uses
  SysUtils;

function GetRemoteName (Address: Integer): String;
begin
  case Address of
    0:  Result := 'Classic WinTV Remote';
    30: Result := 'Modern WinTV PVR2 Remote';
    31: Result := 'Modern WinTV PVR Remote';
    else Result := UnknownRemote + ' (' + IntToStr (Address) + ')';
  end;
end;

function GetKeyName (Address, KeyCode: Integer): String;
begin
  case Address of
    0:  case KeyCode of
          0..9: Result := IntToStr (KeyCode);
          12: Result := 'Radio';
          13: Result := 'Mute';
          15: Result := 'TV';
          16: Result := 'Vol+';
          17: Result := 'Vol-';
          30: Result := 'Reserved';
          32: Result := 'Ch+';
          33: Result := 'Ch-';
          34: Result := 'Source';
          38: Result := 'Minimize';
          46: Result := 'Full Screen';
          else Result := UnknownKey + ' (' + IntToStr (KeyCode) + ')';
        end;
    30: case KeyCode of
          0..9: Result := IntToStr (KeyCode);
          10: Result := '* / Text';
          11: Result := 'Red';
          12: Result := 'Radio';
          13: Result := 'Menu';
          14: Result := '# / Sub/CC';
          15: Result := 'Mute';
          16: Result := 'Vol+';
          17: Result := 'Vol-';
          18: Result := 'Prev. Ch.';
          20: Result := 'Up';
          21: Result := 'Down';
          22: Result := 'Left';
          23: Result := 'Right';
          24: Result := 'Videos';
          25: Result := 'Music';
          26: Result := 'Pictures';
          27: Result := 'Guide';
          28: Result := 'TV';
          30: Result := 'Skip';
          31: Result := 'Back/Exit';
          32: Result := 'Ch+';
          33: Result := 'Ch-';
          36: Result := 'Replay';
          37: Result := 'OK';
          41: Result := 'Blue';
          46: Result := 'Green';
          48: Result := 'Pause';
          50: Result := 'Rewind';
          52: Result := 'Fast Forward';
          53: Result := 'Play';
          54: Result := 'Stop';
          55: Result := 'Record';
          56: Result := 'Yellow';
          59: Result := 'Go';
          61: Result := 'Power';
          else Result := UnknownKey + ' (' + IntToStr (KeyCode) + ')';
        end;
    31: case KeyCode of
          0..9: Result := IntToStr (KeyCode);
          11: Result := 'Red';
          12: Result := 'Reserved';
          13: Result := 'Menu';
          15: Result := 'Mute';
          16: Result := 'Vol+';
          17: Result := 'Vol-';
          30: Result := 'Skip';
          31: Result := 'Back/Exit';
          32: Result := 'Ch+';
          33: Result := 'Ch-';
          36: Result := 'Replay';
          37: Result := 'OK';
          41: Result := 'Blue';
          46: Result := 'Green';
          48: Result := 'Pause';
          50: Result := 'Rewind';
          52: Result := 'Fast Forward';
          53: Result := 'Play';
          54: Result := 'Stop';
          55: Result := 'Record';
          56: Result := 'Yellow';
          59: Result := 'Go';
          60: Result := 'Full';
          61: Result := 'Power';
          else Result := UnknownKey + ' (' + IntToStr (KeyCode) + ')';
        end;
    else Result := UnknownKey + ' (' + IntToStr (KeyCode) + ')';
  end;
end;

end.
