{
WTVIRBridge
Copyright (c) 2004-07 Oliver Frietsch

WTVIRBridge is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

WTVIRBridge is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
}

unit log; {OK}

interface

uses
  Windows, Forms, StdCtrls, Classes, Controls, ExtCtrls, SysUtils, Dialogs;

type
  TLogForm = class(TForm)
    BottomPanel: TPanel;
    ClearBtn: TButton;
    CloseBtn: TButton;
    LogLB: TListBox;
    SaveBtn: TButton;
    SaveDialog: TSaveDialog;
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    procedure LogEvent (Event: String);
    procedure LogKey (Address, KeyCode: Integer);
  end;

var
  LogForm: TLogForm;

implementation

uses
  main, lngstrings, broadcast, irremote;

{$R *.DFM}

procedure TLogForm.FormHide(Sender: TObject);
begin
  TaskbarButton (False, Self);
end;

procedure TLogForm.FormShow(Sender: TObject);
begin
  TaskbarButton (True, Self);
end;

procedure TLogForm.LogEvent (Event: String);
begin
  Event := StringReplace (Event, #13, ' ', [rfReplaceAll]);
  Event := StringReplace (Event, #10, ' ', [rfReplaceAll]);
  LogLB.Items.Insert (0, '[' + FormatDateTime (DateFormat, Now) + ']  ' + Event);
  while LogLB.Items.Count > 100 do
    LogLB.Items.Delete (LogLB.Items.Count - 1 - 10); //Always keep first 10 items in log
end;

procedure TLogForm.LogKey (Address, KeyCode: Integer);
var
  str: String;
begin
  str := KeyLogEntry + ' ' + GetRemoteName (Address) + ' - ' + GetKeyName (Address, KeyCode);
  LogEvent (str);
end;

procedure TLogForm.ClearBtnClick(Sender: TObject);
begin
  LogLB.Clear;
end;

procedure TLogForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TLogForm.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog.Execute
    then try
           LogLB.Items.SaveToFile (SaveDialog.FileName);
         except
           MessageBox (Handle, PChar (ErrorSaveLog), PChar (ErrorTitle), mb_IconError);
         end;
end;

procedure TLogForm.FormCreate(Sender: TObject);
begin
  LogEvent ('WTVIRBridge ' + GetVersion + ' (' + BroadcastType + ' Edition)');
  LogEvent ('IRRemote DLL ' + IR_GetDLLVersion);
end;

end.
